import java.io.*;

class TopoSort
{ 
    int n;
    Element [] Liste; // Liste aller Elemente
    Element [] freieElemente; // Liste der Elemente ohne Vorgnger
    int AnzfreieElemente;     // (als Stapel gespeichert)

    static IntReader input;

public static void main (String[] args) throws IOException
    {
	input = new IntReader(args);
	TopoSort x = new TopoSort();
    }

TopoSort() throws IOException
{
    System.out.println("Topologischen Sortieren.");
    // Einlesen
    n = input.readInt();
        
    // Inititalisieren array:
    Liste = new Element [n+1];
    for (int i=1; i<=n; i++) Liste[i] = new Element(i);

    // Einlesen Paare
    try	{ 
	for (;;) {
	    Element e = Liste[input.readInt()];
	    Element f = Liste[input.readInt()];
	    Paar x = new Paar(e,f);
	    x.next = e.ersterNachfolger;
	    e.ersterNachfolger = x;
	    f.anzVorgnger++;
    }   }
    catch(EOFException e) {}
	
    // Vorbereiten:
    freieElemente = new Element [n];
    AnzfreieElemente = 0;
    for (int i=1; i<=n; i++) {
	Element e = Liste[i];
	if (e.anzVorgnger==0)
	    freieElemente[AnzfreieElemente++]=e;
    }
    // Sortieren:
    System.out.println("");
 sort:
    for (int i=1; i<=n; i++) {
	if (AnzfreieElemente == 0) {
	    System.out.print("Die Eingabe enthlt einen Kreis: (");
	    // solange probieren bis ich ein Element im Kreis finde...
	    for(int j=1; KreisLauf(Liste[j]) > DONE; j++);
	    System.out.print(") <--\n");
	    break sort;
	}
	// Whle ein Paar ohne Vorgnger
	Element x = freieElemente[--AnzfreieElemente];
	System.out.println(x);
	// Entferne ausgehende Paare:
	Paar z = x.ersterNachfolger;
	while (z != null) {
	    z.j.anzVorgnger--;
	    if (z.j.anzVorgnger == 0)
		freieElemente[AnzfreieElemente++]=z.j;
	    z = z.next;
	}
    }
}

final int ALLDONE=0;
final int DONE=1;
final int APDX=2;

int KreisLauf(Element e) {
	// bin ich Wurmfortsatz?
	if(e.anzVorgnger==0 || e.ersterNachfolger==null) { 
		// als Wurmfortsatz markieren
		e.anzVorgnger=0;
		return APDX; 
	}
	// bin ich schon durchlaufen?
	if(e.anzVorgnger < 0) {
		// als durchlaufen entMarkieren....
		e.anzVorgnger*=(-1);
		return DONE; 
	};
	// als durchlaufen Markieren....
	e.anzVorgnger*=(-1);
	// naechster...
	Paar r = e.ersterNachfolger;
	int lr;
  naechster:
	while(true){
		// ok, war ein wurmfortsatz....
		if (r == null) { 
			// als Wurmfortsatz markieren
			e.anzVorgnger=0;
			e.anzVorgnger*=(-1);
			return APDX;
		}
		lr = KreisLauf(r.j);
		if (lr == ALLDONE) {return ALLDONE;}
		if (lr == DONE) {break naechster;}
		r=r.next;
	}
	// und ausgeben...
	System.out.print(" " + e.name + " ");
	// iss der Kreis schon rund???
	if(e.anzVorgnger > 0) {return ALLDONE;}
	// als durchlaufen entMarkieren....
	e.anzVorgnger*=(-1);
	// wir sind noch im Kreis....
	return DONE;
}


}

class Element{
	int name, anzVorgnger;
	Paar ersterNachfolger;
	Element (int i) {
	    name = i;
	    anzVorgnger = 0; 
	    ersterNachfolger = null;
	}
	public String toString() {return String.valueOf(name); }
}


class Paar {
	Element i,j;
	Paar next;
	Paar(Element ii, Element jj) {i = ii; j = jj;}
}
